<template>
  <input
    v-if="parameter.type === 'string+inputmask+float'"
    v-model="$v[parameter.key].$model"
    v-debounce:1s="updateInput"
    :placeholder="parameter.placeholder"
    v-bind="addProperties(parameter, HTMLInputElement)"
    class="form-control"
    :class="{ 'is-invalid': $v[parameter.key].$invalid }"
    type="number"
    :step="0.01"
    debounce-events="input"
    :disabled="disabled"
    @keypress="numberOnly($event)"
  />
</template>

<script>
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    updateValue: {
      type: Function,
      default: () => ({}),
    },
    validations: {
      type: Function,
      default: () => ({}),
    },
    changeStateScenario: {
      type: Function,
      default: () => ({}),
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      [this.parameter.key]: 0,
    };
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
  },
  watch: {
    // Changes on the action
    param() {
      this[this.parameter.key] = this.getParamValue();
    },
  },
  mounted() {
    this.HTMLInputElement = HTMLInputElement;
    if (this.$v[this.parameter.key].$invalid) {
      this.changeStateScenario(this.parameter.key, true);
    }
  },
  beforeMount() {
    this[this.parameter.key] = this.getParamValue();
  },
  validations() {
    return this.validations(this.parameter);
  },
  methods: {
    getParamValue() {
      let value = 0;
      if (this.param.value != null && this.param.value !== undefined) {
        value = this.param.value;
      } else if (this.param.default) {
        value = this.param.default;
      }
      return parseFloat(value);
    },
    numberOnly(value) {
      const correct =
        /^\d+$/.test(value.key) ||
        (value.key === '.' && this.param.value.split('.').length - 1 === 0);
      if (!correct) {
        value.preventDefault();
      }
    },
    async updateInput(value, event) {
      if (this.disabled) return;
      if (!this.$v[this.parameter.key].$error) {
        this.changeStateScenario(this.parameter.key, false);
        await this.updateValue(
          this.parameter.key,
          event.target.value ? parseFloat(event.target.value) : ''
        );
      } else {
        this.changeStateScenario(this.parameter.key, true);
      }
    },
  },
};
</script>
